package scanner

import (
	"path/filepath"

	"git.akyoto.dev/cli/q/src/config"
	"git.akyoto.dev/cli/q/src/core"
	"git.akyoto.dev/cli/q/src/fs"
	"git.akyoto.dev/cli/q/src/types"
)

// Scan scans the list of files.
func Scan(files []string) (<-chan *fs.File, <-chan *core.Function, <-chan types.Type, <-chan error) {
	scanner := Scanner{
		files:     make(chan *fs.File),
		functions: make(chan *core.Function),
		types:     make(chan types.Type),
		errors:    make(chan error),
	}

	go func() {
		scanner.queueDirectory(filepath.Join(config.Library, "mem"), "mem")
		scanner.queue(files...)
		scanner.group.Wait()
		close(scanner.files)
		close(scanner.functions)
		close(scanner.types)
		close(scanner.errors)
	}()

	return scanner.files, scanner.functions, scanner.types, scanner.errors
}
